% Example 4.1

length=1.; nx=11; nd=2; ne=nd*(nx-1)+1; dx=length/(ne-1);
a=1.; kappa=1.; u0=1.; tp=0.1; h=length/(nx-1.);
uexp(1:nx)=zeros(1,nx); uimp(1:nx)=zeros(1,nx);
xa=((1:nx)-1)*h;
fprintf(' Example 4.1  \n');
fprintf('  \n');

% exact solution
xe(1)=0.; ue(1)=0.;
for na=2:ne-1
    x=(na-1)*dx; xe(na)=x;
    et=1.; m=0; sum=0.;
    while et >= 0.0001
        dm=pi*(2*m+1)/length; et=exp(-kappa*dm*dm*tp)/(2*m+1);
        sum=sum+et*sin(dm*x); m=m+1;
    end
    ue(na)=4.*u0*sum/pi;
end
xe(ne)=length; ue(ne)=0.;

ud(1:nx)=u0*ones(1,nx);
b=0.5; tau=b*h*h/kappa; nts=round(tp/tau);
fprintf(' Explicit scheme \n'); fprintf('  Space step - %f  \n',h);
fprintf('  Time step  - %f  \n',tau);
for k=1:nts
     time=k*tau;
     [uu]=heat_1d_un(ud,kappa,a,nx,h,time,tau,b,0.,0,0,'f1_e41','f2_e41','fs_e41');
     ud(1:nx)=uu(1:nx);
end    
uexp(1:nx)=uu(1:nx);
errexp=norm(ue(1:nd:ne)-uexp)/norm(ue(1:nd:ne));
fprintf('  Relative error  - %f  \n',errexp);
fprintf('\n');

ud(1:nx)=u0*ones(1,nx);
b=1.66666; tau=b*h*h/kappa; nts=round(tp/tau);
fprintf(' Implicit scheme \n'); fprintf('  Space step - %f  \n',h);
fprintf('  Time step  - %f  \n',tau);
for k=1:nts
     time=k*tau;
     [uu]=heat_1d_un(ud,kappa,a,nx,h,time,tau,b,0.45,0,0,'f1_e41','f2_e41','fs_e41');
     ud(1:nx)=uu(1:nx);
end    
uimp(1:nx)=uu(1:nx);
errimp=norm(ue(1:nd:ne)-uimp)/norm(ue(1:nd:ne));
fprintf('  Relative error  - %f  \n',errimp);
fprintf('\n');

figure(1);
plot(xa,uexp,'k--',xe,ue,'k-');
xlabel(' x ');
ylabel(' u ');
title(' Example 4.1 (Explicit scheme) ');
figure(2);
plot(xa,uimp,'k--',xe,ue,'k-');
xlabel(' x ');
ylabel(' u ');
title(' Example 4.1 (Implicit scheme) ');
clear all;