% Example 4.4

l=1.; nx=21; h=l/(nx-1); tp=1.0e6;
ro=1000.; cs=2100.; cl=4200.; as=2.25; al=0.56; lh=3.3e5; up=273.;

tau=h*h*0.5/max(as/(ro*cs),al/(ro*cl));
nts=round(tp/tau);
entu(1:nx)=zeros(1,nx); entd(1:nx)=zeros(1,nx);
fprintf(' Example 4.4  \n'); fprintf(' \n');
fprintf('  Space step - %f  m\n',h);
fprintf('  Time step  - %f  s\n',tau);
fprintf('  Proccess duration - %e  s\n',tp);
fprintf(' \n');
fprintf('  Please wait...computations are in progress \n');
fprintf('  ..... \n');
for n=1:nx
    x=(n-1)*h; xa(n)=x; ud(n)=7.*x/l+273.; us(n)=ud(n);
    entd(n)=cs*ud(n); a(n)=as; um(n)=up;
    if ud(n) >= up
        entd(n)=cl*ud(n)-(cl-cs)*up+lh;
        a(n)=al;
    end    
end
t(1)=0.; fp(1)=0.;
for k=1:nts
    time=k*tau; t(k+1)=time;
    [entu,uu,sf]=stefan_1d(entd,ud,ro,cs,cl,as,al,lh,up,nx,h,tau,time,0,0,'f1_e44','f2_e44','fs_e44');
    entd(1:nx)=entu(1:nx); ud(1:nx)=uu(1:nx);
    sum=0.5*(sf(1)+sf(nx));
    for n=2:nx-1
        sum=sum+sf(n);
    end
    fp(k+1)=h*sum;
end
figure(1);
plot(xa,uu,'k-',xa,us,'k--',xa,um,'k.');
xlabel(' x ');
ylabel(' u ');
title(' Example 4.4 (Temperature) ');
figure(2);
plot(t,fp,'k-');
xlabel(' t ');
ylabel(' y ');
title(' Example 4.4 (Phase front) ');
clear all;