% One-dimensional Stefan problem

function [entu,uu,sf]=stefan_1d(entd,ud,ro,cs,cl,as,al,lh,up,nx,h,tau,time,bl,br,fbl,fbr,fs)

x=((1:nx)-1)*h;
if tau*max(as/(ro*cs),al/(ro*cl))/(h*h) > 0.5
    disp('Scheme is unstable'); return;
end

% explicit scheme
b=tau/(ro*h*h);
for n=1:nx-1
    a(n)=as;
    if ud(n) >= up
        a(n)=al;
    end    
end
if bl == 0
    u=feval(fbl,time); entu(1)=cs*u;
    if u >= up
        entu(1)=cl*u-(cl-cs)*up+lh;
    end        
else
    entu(1)=entd(1)+2.*b*a(1)*(ud(2)-ud(1))-2.*b*h*feval(fbl,time-tau);
end    
for n=2:nx-1
    entu(n)=entd(n)+b*(a(n)*(ud(n+1)-ud(n))-a(n-1)*(ud(n)-ud(n-1)))+...
                 tau*feval(fs,x(n),time-tau)/ro;
end
if br == 0
    u=feval(fbr,time); entu(nx)=cs*u;
    if u >= up
        entu(nx)=cl*u-(cl-cs)*up+lh;
    end        
else
    entu(nx)=entd(nx)+2.*b*a(nx)*(ud(nx-1)-ud(nx))+2.*b*h*feval(fbr,time-tau);
end
for n=1:nx
    uu(n)=entu(n)/cs; a(n)=as; sf(n)=1.;
    if and(entu(n) > cs*up,entu(n) < cs*up+lh)
        uu(n)=up; a(n)=as; sf(n)=1.-(entu(n)-cs*up)/lh;
    end
    if entu(n) >= cs*up+lh
        uu(n)=(entu(n)-lh)/cl+up*(cl-cs)/cl; a(n)=al; sf(n)=0.;
    end        
end