% Example 7.3

nx=17; ny=17; lx=1.; ly=1.; hx=lx/(nx-1); hy=ly/(ny-1);
ui=zeros(nx,ny); e=zeros(nx,ny); ue=zeros(nx,ny);
[u,k]=helmgoltz_2d_cg(ui,'f_e73','a_e73','b_e73',lx,ly,nx,ny,'g1_e73','g2_e73','g3_e73','g4_e73');

% Exact solution
for n=1:nx
    x=(n-1)*hx; xe(n)=x;
    for m=1:ny
        y=(m-1)*hy; ye(m)=y; ue(n,m)=sin(x*y);
        e(n,m)=u(n,m)-ue(n,m);
    end
end
err=norm(e,'fro')/norm(ue,'fro');
fprintf(' Example 7.3  \n');
fprintf('  Relative error - %f   \n',err);
fprintf('  Number of iterations - %i  \n',k); fprintf(' \n');
mesh(xe,ye,u');
xlabel(' x '); ylabel(' y '); zlabel(' u ');
title(' Example 7.3 ');
clear all;